HDU 4771 (DFS+BFS)

Problem Description

  Harry Potter has some precious. For example, his invisible robe, his wand and his owl. When Hogwarts school is in holiday, Harry Potter has to go back to uncle Vernon‘s home. But he can‘t bring his precious with him. As you know, uncle Vernon never allows such magic things in his house. So Harry has to deposit his precious in the Gringotts Wizarding Bank which is owned by some goblins. The bank can be considered as a N × M grid consisting of N × M rooms. Each room has a coordinate. The coordinates of the upper-left room is (1,1) , the down-right room is (N,M) and the room below the upper-left room is (2,1)..... A 3×4 bank grid is shown below:  Some rooms are indestructible and some rooms are vulnerable. Goblins always care more about their own safety than their customers‘ properties, so they live in the indestructible rooms and put customers‘ properties in vulnerable rooms. Harry Potter‘s precious are also put in some vulnerable rooms. Dudely wants to steal Harry‘s things this holiday. He gets the most advanced drilling machine from his father, uncle Vernon, and drills into the bank. But he can only pass though the vulnerable rooms. He can‘t access the indestructible rooms. He starts from a certain vulnerable room, and then moves in four directions: north, east, south and west. Dudely knows where Harry‘s precious are. He wants to collect all Harry‘s precious by as less steps as possible. Moving from one room to another adjacent room is called a ‘step‘. Dudely doesn‘t want to get out of the bank before he collects all Harry‘s things. Dudely is stupid.He pay you $1,000,000 to figure out at least how many steps he must take to get all Harry‘s precious.

Input

  There are several test cases.   In each test cases:   The first line are two integers N and M, meaning that the bank is a N × M grid(0<N,M <= 100).   Then a N×M matrix follows. Each element is a letter standing for a room. ‘#‘ means a indestructible room, ‘.‘ means a vulnerable room, and the only ‘@‘ means the vulnerable room from which Dudely starts to move.   The next line is an integer K ( 0 < K <= 4), indicating there are K Harry Potter‘s precious in the bank.   In next K lines, each line describes the position of a Harry Potter‘s precious by two integers X and Y, meaning that there is a precious in room (X,Y).   The input ends with N = 0 and M = 0

Output

  For each test case, print the minimum number of steps Dudely must take. If Dudely can‘t get all Harry‘s things, print -1.

Sample Input

2 3

##@

#.#

1

2 2

4 4

#@##

....

####

....

2

2 1

2 4

0 0

Sample Output

-1 5

Source

2013 Asia Hangzhou Regional Contest

最近一直再做搜索的题目  姿势不知道有没有涨了许多  可以可以

这题 还是坑了很久的 刚开始是想不断bfs 找到最近的一个点 记录步数 然后更新起点 继续bfs 但是 有bug 有反例 gg

先找到k处宝藏与出发点之间的最短路 bfs处理  然后dfs 找到最短连接路

这个地方刚开始还想用并查集 但是题目的要求的联通是首尾相接的 gg

dfs+bfs

#include<bits/stdc++.h>
using namespace std;
char a[105][105];
int mp[105][105];
map<int,int>flag;
int mpp[105][105];
int shorpath[6][2];
int dis[4][2]={{1,0},{-1,0},{0,1},{0,-1}};
int n,m;
int k;
int s_x,s_y;
int parent[30];
int jishu=0;
int A[6][6];
int re=100000;
int sum;
struct node
{
    int x;
    int y;
    int step;
};
int Find(int n)
{
    if(n!=parent[n])
        n=Find(parent[n]);
    return n;
}
void unio( int ss,int bb)
{
    ss=Find(ss);
    bb=Find(bb);
    if(ss!=bb)
    parent[ss]=bb;
}
queue<node>q;
node N,now;
void init_()
{
    for(int i=1;i<=n;i++)
        for(int j=1;j<=m;j++)
           mpp[i][j]=mp[i][j];
}
int bfs(int a,int b,int c,int d)
{
    init_();
    while(!q.empty())
    {
        q.pop();
    }
    N.x=a;
    N.y=b;
    N.step=0;
    q.push(N);
    mpp[a][b]=0;
    while(!q.empty())
    {
        now=q.front();
        q.pop();
        if(now.x==c&&now.y==d)
            return now.step;
        for(int i=0;i<4;i++)
        {
            int aa=now.x+dis[i][0];
            int bb=now.y+dis[i][1];
            if(aa>0&&aa<=n&&bb>0&&bb<=m&&mpp[aa][bb])
            {
                mpp[aa][bb]=0;
                N.x=aa;
                N.y=bb;
                N.step=now.step+1;
                q.push(N);
            }
        }
    }
    return -1;
}
void init()
{
    for(int i=1;i<=n;i++)
        for(int j=1;j<=m;j++)
           mp[i][j]=0;
    for(int i=0;i<=30;i++)
         parent[i]=i;
    re=100000;
}
/*void kruskal()
{
    int re=0;
   for(int i=0;i<jishu;i++)
 {
     int qq=A[i].s;
     int ww=A[i].e;
     //cout<<re<<endl;
     if(Find(qq)!=Find(ww))
     {
         unio(qq,ww);
         re+=A[i].x;
     }
}
  printf("%d\n",re);
}*/
void dfs(int n,int ce)
{
    if(ce==k)
    {
        if(sum<re)
        {
            re=sum;
        }
        //printf("%d\n",re);
        return ;
    }
    for(int i=0;i<=k;i++)
    {
        if(i!=n&&flag[i]==0)
        {
            sum+=A[n][i];
            flag[i]=1;
            dfs(i,ce+1);
            sum-=A[n][i];
            flag[i]=0;
        }
    }
}
int main()
{
    while(scanf("%d%d",&n,&m)!=EOF)
    {
        if(n==0&&m==0)
            break;
        init();
        getchar();
        for(int i=1;i<=n;i++)
        {
            for(int j=1;j<=m;j++)
            {
                scanf("%c",&a[i][j]);
                if(a[i][j]==‘@‘)
                {
                    s_x=i;
                    s_y=j;
                }
                if(a[i][j]==‘.‘||a[i][j]==‘@‘)
                    mp[i][j]=1;
            }
            getchar();
        }
            scanf("%d",&k);
            shorpath[0][0]=s_x;
            shorpath[0][1]=s_y;
            for(int i=1;i<=k;i++)
               scanf("%d%d",&shorpath[i][0],&shorpath[i][1]);
            jishu=0;
            for(int i=0;i<=k;i++)
                for(int j=0;j<=k;j++)
            {
                A[i][j]=bfs(shorpath[i][0],shorpath[i][1],shorpath[j][0],shorpath[j][1]);
            }
            sum=0;
            flag[0]=1;
            dfs(0,0);
            printf("%d\n",re);

     }

return 0;
}

时间: 2024-10-01 16:21:44

HDU 4771 (DFS+BFS)的相关文章

HDU 4771 Stealing Harry Potter&#39;s Precious dfs+bfs

Stealing Harry Potter's Precious Problem Description Harry Potter has some precious. For example, his invisible robe, his wand and his owl. When Hogwarts school is in holiday, Harry Potter has to go back to uncle Vernon's home. But he can't bring his

hdu 4771 Stealing Harry Potter&#39;s Precious (2013亚洲区杭州现场赛)(搜索 bfs + dfs) 带权值的路径

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4771 题目意思:'@'  表示的是起点,'#' 表示的是障碍物不能通过,'.'  表示的是路能通过的: 目的:让你从 '@' 点出发,然后每个点只能走一次,求出最小的距离: 解题思路:先用 bfs 求解出任意两点之间的距离,用 ans[i][j],表示点 i 到点  j 的距离: 然后用 dfs 递归求出从起点经过所有点的距离中,比较出最小的: AC代码: 1 #include<iostream>

HDU 4771 Stealing Harry Potter&#39;s Precious(BFS + DFS)

HDU 4771 Stealing Harry Potter's Precious 题目链接 题意:给定人的起始位置和k个宝物,求人拿完全部宝物最小的步数 思路:先bfs打出两两之间路径,然后dfs暴力求答案,因为宝物才4个,所以暴力是没问题的 代码: #include <stdio.h> #include <string.h> #include <queue> #include <algorithm> using namespace std; const

【HDU 4771 Stealing Harry Potter&#39;s Precious】BFS+状压

2013杭州区域赛现场赛二水... 类似“胜利大逃亡”的搜索问题,有若干个宝藏分布在不同位置,问从起点遍历过所有k个宝藏的最短时间. 思路就是,从起点出发,搜索到最近的一个宝藏,然后以这个位置为起点,搜索下一个最近的宝藏,直至找到全部k个宝藏.有点贪心的感觉. 由于求最短时间,BFS更快捷,但耗内存,这道题就卡在这里了... 这里记录了我几次剪枝的历史...题目要求内存上限32768KB,就差最后600KB了...但我从理论上觉得已经不能再剪了,留下的结点都是盲目式搜索必然要访问的结点. 在此贴

hdu 4771 Stealing Harry Potter&#39;s Precious (BFS+状压)

题意: n*m的迷宫,有一些格能走(“.”),有一些格不能走(“#”).起始点为“@”. 有K个物体.(K<=4),每个物体都是放在“.”上. 问最少花多少步可以取完所有物体. 思路: BFS+状压,看代码. 代码: struct node{ int x,s; node(int _x,int _s){ x=_x, s=_s; } }; int n,m,k,sx,sy; char graph[105][105]; int px[5],py[5]; int dp[105][105][35]; int

HDU 4771 Stealing Harry Potter&#39;s Precious (生成排列+枚举 + BFS)

Stealing Harry Potter's Precious Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1982    Accepted Submission(s): 931 Problem Description Harry Potter has some precious. For example, his invisib

hdu 4771 13 杭州 现场 B - Stealing Harry Potter&#39;s Precious 暴力bfs

Description Harry Potter has some precious. For example, his invisible robe, his wand and his owl. When Hogwarts school is in holiday, Harry Potter has to go back to uncle Vernon's home. But he can't bring his precious with him. As you know, uncle Ve

hdu 4771 Stealing Harry Potter&#39;s Precious (状态压缩+bfs)

Stealing Harry Potter's Precious Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1297    Accepted Submission(s): 619 Problem Description Harry Potter has some precious. For example, his invisib

hdu 4771 Stealing Harry Potter&#39;s Precious(bfs)

题目链接:hdu 4771 Stealing Harry Potter's Precious 题目大意:在一个N*M的银行里,贼的位置在'@',现在给出n个宝物的位置,现在贼要将所有的宝物拿到手,问最短的路径,不需要考虑离开. 解题思路:因为宝物最多才4个,加上贼的位置,枚举两两位置,用bfs求两点距离,如果存在两点间不能到达,那么肯定是不能取完所有的宝物.然后枚举取宝物的顺序,维护ans最小. #include <cstdio> #include <cstring> #inclu